#ifndef PG_CONTRIB_TINY_H_INCLUDED__
#define PG_CONTRIB_TINY_H_INCLUDED__

typedef struct int24
{
	char data[3];
} int24;

#ifndef INT8_MAX
#define INT8_MAX            ((int16)(0x007f))
#endif

#ifndef INT8_MIN
#define INT8_MIN            ((int16)(0xff80))
#endif

#define Int8GetInt8(X)      (X)
#define Int8GetInt16(X)     ((int16)X)
#define Int8GetInt32(X)     ((int32)X)
#define Int8GetInt64(X)     ((int64)X)

#define Int16GetInt8(X)     ((int8)X)
#define Int32GetInt8(X)     ((int8)X)
#define Int64GetInt8(X)     ((int8)X)

#define Int24GetInt24(X)    (X)

#define INT24_MAX           ((int32)(0x007fffff))
#define INT24_MIN           ((int32)(0xff800000))

#define DatumGetInt24(X)    ((int24) GET_3_BYTES(X))
#define DatumGetInt8(X)     ((int8) GET_1_BYTE(X))
#define Int24GetDatum(X)    ((Datum) SET_3_BYTES(X))
#define Int8GetDatum(X)     ((Datum) SET_1_BYTE(X))
#define PG_GETARG_INT24(n)  DatumGetInt24(PG_GETARG_DATUM(n))
#define PG_GETARG_INT8(n)   DatumGetInt8(PG_GETARG_DATUM(n))
#define PG_RETURN_INT24(x)  return Int24GetDatum(x)
#define PG_RETURN_INT8(x)   return Int8GetDatum(x)

#define INTERNAL_CMP_INT8(x,y) (((int)(x)) - ((int)(y)))

int24 GET_3_BYTES(Datum);
Datum SET_3_BYTES(int24);

int24 Int8GetInt24(int8);
int24 Int16GetInt24(int16);
int24 Int32GetInt24(int32);
int24 Int64GetInt24(int64);

int8 Int24GetInt8(int24);
int16 Int24GetInt16(int24);
int32 Int24GetInt32(int24);
int64 Int24GetInt64(int24);

int INTERNAL_CMP_INT24(int24 x, int24 y);

#endif /* PG_CONTRIB_TINY_H_INCLUDED__ */
